<?php
require_once('HTML/QuickForm/radio.php');

/**
 * HTML class for a radio type element
 * 
 * @author       Jamie Pratt
 * @access       public
 */
class moodleform_radio extends HTML_QuickForm_radio{
    /**
     * html for help button, if empty then no help
     *
     * @var string
     */
    var $_helpbutton='';
    /**
     * set html for help button
     *
     * @access   public
     * @param array $help array of arguments to make a help button
     */
    function setHelpButton($helpbuttonargs){
        if (!is_array($helpbuttonargs)){
            $helpbuttonargs=array($helpbuttonargs);
        }else{
            $helpbuttonargs=$helpbuttonargs;
        }
        //we do this to to return html instead of printing it 
        //without having to specify it in every call to make a button.
        $defaultargs=array('', '', 'moodle', true, false, '', true);
        $helpbuttonargs=$helpbuttonargs + $defaultargs ;
        $this->_helpbutton=call_user_func_array('helpbutton', $helpbuttonargs);
    }
    /**
     * get html for help button
     *
     * @access   public
     * @return  string html for help button
     */
    function getHelpButton(){
        return $this->_helpbutton;
    }
   /**
    * Automatically generates and assigns an 'id' attribute for the element.
    * 
    * Currently used to ensure that labels work on radio buttons and
    * checkboxes. Per idea of Alexander Radivanovich.
    * Overriden in moodleforms to remove qf_ prefix.
    *
    * @access private
    * @return void 
    */
    function _generateId()
    {
        static $idx = 1;

        if (!$this->getAttribute('id')) {
            $this->updateAttributes(array('id' => substr(md5(microtime() . $idx++), 0, 6)));
        }
    } // end func _generateId
}
?>